# HG changeset patch
# User John Donoghue <john.donoghue@ieee.org>
# Date 1420507094 18000
#      Mon Jan 05 20:18:14 2015 -0500
# Node ID 5a3e6d53a8cde1f9900c67f9b0f088d2bb604ab0
# Parent  a5e6d54bcd602a33054f0b7a56494a6b9df9a097
epstool: added package

* dist-files.mk: added epstool.mk, mingw-epstool-1-fixes.patch

* index.html: added epstool package

* src/default-octave.mk: added epstool as dependancy

* src/mingw-epstool-1-fixes.patch: new file.

* src/octave.mk: added epstool as dependancy

* src/stable-octave.mk: added epstool as dependancy

diff -r a5e6d54bcd60 -r 5a3e6d53a8cd dist-files.mk
--- a/dist-files.mk	Thu Jan 01 08:25:40 2015 -0500
+++ b/dist-files.mk	Mon Jan 05 20:18:14 2015 -0500
@@ -66,6 +66,7 @@
   devil-1-png.patch \
   devil.mk \
   eigen.mk \
+  epstool.mk \
   exiv2-issue847.patch \
   exiv2-r2796.patch \
   exiv2.mk \
@@ -313,6 +314,7 @@
   mdbtools.mk \
   mingw-cairo-1-ssize-t-defined.patch \
   mingw-cfitsio-1-fixes.patch \
+  mingw-epstool-1-fixes.patch \
   mingw-fontconfig-ln_s.patch \
   mingw-glib-1-fixes.patch \
   mingw-glib-2-fixes.patch \
diff -r a5e6d54bcd60 -r 5a3e6d53a8cd index.html
--- a/index.html	Thu Jan 01 08:25:40 2015 -0500
+++ b/index.html	Mon Jan 05 20:18:14 2015 -0500
@@ -1269,6 +1269,10 @@
         <td class="package">gnuplot</td>
         <td class="website"><a href="http://www.gnuplot.info/">gnuplot</a></td>
     </tr>
+   <tr>
+        <td class="package">epstool</td>
+        <td class="website"><a href="http://pages.cs.wisc.edu/">epstool</a></td>
+    </tr>	
     <tr>
         <td class="package">gnutls</td>
         <td class="website"><a href="http://www.gnu.org/software/gnutls/">GnuTLS</a></td>
diff -r a5e6d54bcd60 -r 5a3e6d53a8cd src/default-octave.mk
--- a/src/default-octave.mk	Thu Jan 01 08:25:40 2015 -0500
+++ b/src/default-octave.mk	Mon Jan 05 20:18:14 2015 -0500
@@ -14,7 +14,7 @@
 ifeq ($(USE_SYSTEM_FONTCONFIG),no)
   $(PKG)_FONTCONFIG := fontconfig
 endif
-$(PKG)_DEPS     := blas arpack curl fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack pcre pstoedit qrupdate qscintilla qt readline suitesparse texinfo zlib
+$(PKG)_DEPS     := blas arpack curl epstool fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack pcre pstoedit qrupdate qscintilla qt readline suitesparse texinfo zlib
 ifeq ($(MXE_WINDOWS_BUILD),no)
   $(PKG)_DEPS += x11 xext
 endif
diff -r a5e6d54bcd60 -r 5a3e6d53a8cd src/mingw-epstool-1-fixes.patch
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/mingw-epstool-1-fixes.patch	Mon Jan 05 20:18:14 2015 -0500
@@ -0,0 +1,92 @@
+diff -urN epstool-3.08.orig/makefile epstool-3.08/makefile
+--- epstool-3.08.orig/makefile	2015-01-05 19:01:34.000000000 -0500
++++ epstool-3.08/makefile	2015-01-05 19:54:45.000000000 -0500
+@@ -34,10 +34,12 @@
+ 
+ LONGFILEDEF=
+ LONGFILEMOD=cfile
++WGSVERMOD=wgsver
+ 
+-include $(SRCDIR)/unixcom.mak
++#include $(SRCDIR)/unixcom.mak
++include $(SRCDIR)/mingwcom.mak
+ 
+-EPSOBJPLAT=$(OD)xnodll$(OBJ) $(OD)$(LONGFILEMOD)$(OBJ)
++EPSOBJPLAT=$(OD)xnodll$(OBJ) $(OD)$(LONGFILEMOD)$(OBJ) $(OD)$(WGSVERMOD)$(OBJ)
+ EPSLIB=$(LIBPNGLIBS)
+ 
+ BEGIN=$(OD)lib.rsp
+@@ -45,7 +47,7 @@
+ 
+ include $(SRCDIR)/common.mak
+ 
+-EPSTOOL_ROOT=/usr/local
++EPSTOOL_ROOT=/usr
+ EPSTOOL_BASE=$(prefix)$(EPSTOOL_ROOT)
+ EPSTOOL_DOCDIR=$(EPSTOOL_BASE)/share/doc/epstool-$(EPSTOOL_VERSION)
+ EPSTOOL_MANDIR=$(EPSTOOL_BASE)/man
+diff -urN epstool-3.08.orig/src/mingwcom.mak epstool-3.08/src/mingwcom.mak
+--- epstool-3.08.orig/src/mingwcom.mak	1969-12-31 19:00:00.000000000 -0500
++++ epstool-3.08/src/mingwcom.mak	2015-01-05 20:00:18.000000000 -0500
+@@ -0,0 +1,61 @@
++# Copyright (C) 2002-2005 Ghostgum Software Pty Ltd.  All rights reserved.
++#
++#  This software is provided AS-IS with no warranty, either express or
++#  implied.
++#
++#  This software is distributed under licence and may not be copied,
++#  modified or distributed except as expressly authorised under the terms
++#  of the licence contained in the file LICENCE in this distribution.
++#
++#  For more information about licensing, please refer to
++#  http://www.ghostgum.com.au/ or contact Ghostsgum Software Pty Ltd, 
++#  218 Gallaghers Rd, Glen Waverley VIC 3150, AUSTRALIA, 
++#  Fax +61 3 9886 6616.
++#
++
++# $Id: unixcom.mak,v 1.2 2005/01/11 11:40:19 ghostgum Exp $
++# Unix mingw makefile
++
++
++INSTALL=install -m 644
++INSTALL_EXE=install -m 755
++
++MAKE=make
++CDEFS=-DNONAG $(LONGFILEDEF)
++GSCDEBUG= -g
++GSCFLAGS= $(CDEFS) -Wall -Wstrict-prototypes -Wmissing-declarations -Wmissing-prototypes -fno-builtin -fno-common -Wcast-qual -Wwrite-strings $(CDEBUG) $(GSCDEBUG) $(RPM_OPT_FLAGS) $(XINCLUDE) $(PFLAGS) $(LIBPNGCFLAGS) $(GTKCFLAGS) -I$(SRCWIN)
++CCAUX=$(TOOL_PREFIX)gcc
++CC=$(TOOL_PREFIX)gcc
++LFLAGS=$(PLINK) $(LIBPNGLIBS) $(GTKLIBS)
++CLINK=$(CC) $(LDFLAGS)
++LINK=$(CC) $(LDFLAGS)
++
++
++COMP=$(CC) -I$(SRCDIR) -I$(OBJDIR) $(CFLAGS) $(GSCFLAGS)
++
++
++NUL=
++DD=/$(NUL)
++SRC=$(SRCDIR)/$(NUL)
++SRCWIN=$(SRCWINDIR)/$(NUL)
++OD=$(OBJDIR)/$(NUL)
++BD=$(BINDIR)/$(NUL)
++OBJ=.o
++EXE=.exe
++CO=-c
++
++FE=-o $(NUL)
++FO=-o $(NUL)
++FEO=-o $(OD)
++FOO=-o $(OD)
++
++CP=cp -f
++RM=rm -f
++RMDIR=rm -rf
++
++default: $(BD)epstool$(EXE)
++
++$(OD)wgsver$(OBJ): $(SRCWIN)wgsver.c $(common_h) $(cdll_h)
++	$(COMP) $(FOO)wgsver$(OBJ) $(CO) $(SRCWIN)wgsver.c
++
++
diff -r a5e6d54bcd60 -r 5a3e6d53a8cd src/octave.mk
--- a/src/octave.mk	Thu Jan 01 08:25:40 2015 -0500
+++ b/src/octave.mk	Mon Jan 05 20:18:14 2015 -0500
@@ -11,7 +11,7 @@
 ifeq ($(USE_SYSTEM_FONTCONFIG),no)
   $(PKG)_FONTCONFIG := fontconfig
 endif
-$(PKG)_DEPS     := blas arpack curl fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack pcre pstoedit qrupdate qscintilla qt readline suitesparse texinfo zlib
+$(PKG)_DEPS     := blas arpack curl epstool fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack pcre pstoedit qrupdate qscintilla qt readline suitesparse texinfo zlib
 ifeq ($(MXE_WINDOWS_BUILD),no)
   $(PKG)_DEPS += x11 xext
 endif
diff -r a5e6d54bcd60 -r 5a3e6d53a8cd src/stable-octave.mk
--- a/src/stable-octave.mk	Thu Jan 01 08:25:40 2015 -0500
+++ b/src/stable-octave.mk	Mon Jan 05 20:18:14 2015 -0500
@@ -11,7 +11,7 @@
 ifeq ($(USE_SYSTEM_FONTCONFIG),no)
   $(PKG)_FONTCONFIG := fontconfig
 endif
-$(PKG)_DEPS     := blas arpack curl fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack pcre pstoedit qrupdate qscintilla qt readline suitesparse texinfo zlib
+$(PKG)_DEPS     := blas arpack curl epstool fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack pcre pstoedit qrupdate qscintilla qt readline suitesparse texinfo zlib
 ifeq ($(MXE_WINDOWS_BUILD),no)
   $(PKG)_DEPS += x11 xext
 endif