diff --git a/philosophy/essays-and-articles.pt-br.po b/philosophy/essays-and-articles.pt-br.po
index 1d85a47..435b38c 100644
--- a/philosophy/essays-and-articles.pt-br.po
+++ b/philosophy/essays-and-articles.pt-br.po
@@ -1,5 +1,5 @@
 # Brazilian Portuguese translation of https://www.gnu.org/philosophy/essays-and-articles.html
-# Copyright (C) 2017 Free Software Foundation, Inc.
+# Copyright (C) 2018 Free Software Foundation, Inc.
 # This file is distributed under the same license as the gnu.org article.
 # Pedro Oliveira <bili@linux.fe.up.pt>, 2001.
 # Miguel Oliveira <pmike@esoterica.pt>, 2001.
@@ -7,12 +7,12 @@
 # Leandro Guimarães Faria Corcete Dutra <leandro.gfc.dutra@gmail.com>, 2009.
 # Aslan Carlos <aslancarlos@gmail.com>, 2012.
 # Rafael Beraldo <rberaldo@cabaladada.org>, 2012.
-# Rafael Fontenelle <rafaelff@gnome.org>, 2017.
+# Rafael Fontenelle <rafaelff@gnome.org>, 2017-2018.
 msgid ""
 msgstr ""
 "Project-Id-Version: essays-and-articles.html\n"
-"POT-Creation-Date: 2017-10-20 16:25+0000\n"
-"PO-Revision-Date: 2017-10-21 14:49-0200\n"
+"POT-Creation-Date: 2018-01-31 17:26+0000\n"
+"PO-Revision-Date: 2018-02-11 03:03-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -21,6 +21,7 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 "X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Outdated-Since: 2018-01-25 13:26+0000\n"
 
 #. type: Content of: <title>
 msgid "Essays and Articles - GNU Project - Free Software Foundation"
@@ -891,22 +892,23 @@ msgstr ""
 msgid ""
 "<a href=\"/philosophy/push-copyright-aside.html\">Science must &ldquo;push "
 "copyright aside&rdquo;</a>, another work of <a href=\"http://www.stallman.org"
-"\">Richard Stallman</a> that appeared in the <a href=\"http://www.nature.com/"
-"nature/debates/e-access/Articles/stallman.html\"> Nature Webdebates</a> in "
-"2001, explains how copyright is impeding progress in scientific research.  "
-"You may also be interested in <a href=\"https://www.plos.org/\">The Public "
-"Library of Science</a>, which is dedicated to making scientific research "
-"freely available to all on the Internet."
+"\">Richard Stallman</a> that appeared in the <a href=\"https://web.archive."
+"org/web/20050729110347/http://www.nature.com/nature/debates/e-access/"
+"Articles/stallman.html\"> Nature Webdebates</a> in 2001, explains how "
+"copyright is impeding progress in scientific research.  You may also be "
+"interested in <a href=\"https://www.plos.org/\">The Public Library of "
+"Science</a>, which is dedicated to making scientific research freely "
+"available to all on the Internet."
 msgstr ""
 "A <a href=\"/philosophy/push-copyright-aside.html\">ciência deve “colocar os "
 "direitos autorais de lado”</a>, outro trabalho de <a href=\"http://www."
-"stallman.org\">Richard Stallman</a> que apareceu no <a href=\"http://www."
-"nature.com/nature/debates/e-access/Articles/stallman.html\"> Nature "
-"Webdebates</a> em 2001, explica como os direitos autorais tem impedido o "
-"progresso na pesquisa cientifica. Você também pode estar interessado em <a "
-"href=\"https://www.plos.org/\">A Livraria Pública de Ciência</a>, que se "
-"dedica a tornar a pesquisa científica livremente disponível para todos na "
-"Internet."
+"stallman.org\">Richard Stallman</a> que apareceu no <a href=\"https://web."
+"archive.org/web/20050729110347/http://www.nature.com/nature/debates/e-access/"
+"Articles/stallman.html\"> Nature Webdebates</a> em 2001, explica como os "
+"direitos autorais tem impedido o progresso na pesquisa cientifica. Você "
+"também pode estar interessado em <a href=\"https://www.plos.org/\">A "
+"Livraria Pública de Ciência</a>, que se dedica a tornar a pesquisa "
+"científica livremente disponível para todos na Internet."
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1104,6 +1106,14 @@ msgstr ""
 msgid "Cultural and Social Issues"
 msgstr "Problemas Sociais e Culturais"
 
+#. type: Content of: <ul><li>
+msgid ""
+"<a href=\"/philosophy/surveillance-testimony.html\">Surveillance Testimony</"
+"a>"
+msgstr ""
+"<a href=\"/philosophy/surveillance-testimony.html\">Testemunho de "
+"vigilância</a>"
+
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"/philosophy/devils-advocate.html\"> Why the Devil's Advocate "
@@ -1565,8 +1575,8 @@ msgstr ""
 "envio de traduções das páginas desse site."
 
 #. type: Content of: <div><p>
-msgid "Copyright &copy; 1996-2017 Free Software Foundation, Inc."
-msgstr "Copyright &copy; 1996-2017 Free Software Foundation, Inc."
+msgid "Copyright &copy; 1996-2018 Free Software Foundation, Inc."
+msgstr "Copyright &copy; 1996-2018 Free Software Foundation, Inc."
 
 #. type: Content of: <div><p>
 msgid ""