diff --git a/philosophy/fighting-software-patents.pt-br.po b/philosophy/fighting-software-patents.pt-br.po
index 8da8920..9c6c86a 100644
--- a/philosophy/fighting-software-patents.pt-br.po
+++ b/philosophy/fighting-software-patents.pt-br.po
@@ -1,32 +1,34 @@
 # Brazilian Portuguese translation of http://www.gnu.org/philosophy/fighting-software-patents.html
 # Copyright (C) 2005 Free Software Foundation, Inc.
 # This file is distributed under the same license as the original article.
-# César Blum Silveira, 2005.
+# César Blum Silveira <cesarbs@brturbo.com>, 2005.
 # Jan 2015: GNUNify.
-#
+# Rafael Fontenelle <rafaelff@gnome.org>, 2017.
 msgid ""
 msgstr ""
 "Project-Id-Version: fighting-software-patents.html\n"
 "POT-Creation-Date: 2015-01-05 10:09+0100\n"
-"PO-Revision-Date: 2015-01-20 21:20+0100\n"
-"Last-Translator: Thérèse Godefroy <godef.th AT free.fr>\n"
+"PO-Revision-Date: 2017-04-20 22:25-0300\n"
+"Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=2; plural=(n > 1);\n"
+"X-Generator: Virtaal 1.0.0-beta1\n"
 
 #. type: Content of: <title>
 msgid ""
 "Fighting Software Patents - Singly and Together - GNU Project - Free "
 "Software Foundation"
 msgstr ""
-"Combatento Patentes de Sofware - Uma a uma e Todas Juntas - Projeto GNU - "
+"Combatendo Patentes de Software - Uma a uma e Todas Juntas - Projeto GNU - "
 "Free Software Foundation"
 
 #. type: Content of: <h2>
 msgid "Fighting Software Patents - Singly and Together"
-msgstr "Combatento Patentes de Sofware - Uma a uma e Todas Juntas"
+msgstr "Combatendo Patentes de Software - Uma a uma e Todas Juntas"
 
 #. type: Content of: <p>
 msgid "by Richard Stallman"
@@ -38,7 +40,7 @@ msgid ""
 "design decision carries a risk of stepping on a patent, which can destroy "
 "your project."
 msgstr ""
-"Patentes de sofware são equivalentes a minas terrestres num projeto de "
+"Patentes de software são equivalentes a minas terrestres num projeto de "
 "software: cada decisão sobre o visual carrega o risco de pisar numa patente, "
 "que pode destruir o seu projeto."
 
@@ -52,13 +54,13 @@ msgid ""
 "that covered various parts of a single important program. It is so much work "
 "to do such a study that only one has been done."
 msgstr ""
-"Desenvolver um programa grande e complexo significa combinar várias idéias, "
+"Desenvolver um programa grande e complexo significa combinar várias ideias, "
 "quase sempre centenas ou milhares delas. Num país que permite patentes de "
-"software, as chances são de que alguma fração substancial das idéias no seu "
+"software, as chances são de que alguma fração substancial das ideias no seu "
 "programa já vão estar patenteadas por várias companhias. Talvez centenas de "
 "patentes vão cobrir partes do seu programa. Um estudo feito em 2004 "
 "encontrou quase 300 patentes americanas que cobriam várias partes de um "
-"único prorgama importante. É tão trabalhoso realizar tal estudo que apenas "
+"único programa importante. É tão trabalhoso realizar tal estudo que apenas "
 "um foi feito até agora."
 
 #. type: Content of: <p>
@@ -77,14 +79,14 @@ msgstr ""
 "Em termos práticos, se você é um desenvolvedor de software, você vai "
 "normalmente ser ameaçado por uma patente algumas vezes. Quando isso "
 "acontece, você pode sair ileso se você encontrar chão legal para derrubar a "
-"patente. Você pode tentá-lo; se você tiver sucesso, isso vai significar uma "
+"patente. Você pode tentar; se você tiver sucesso, isso vai significar uma "
 "mina a menos no campo minado. Se essa patente for particularmente ameaçadora "
 "para o público, a <a href=\"http://www.pubpat.org\">Fundação pelas Patentes "
-"Públicas (pubpat.org)</a> pode se interessar pelo caso; essa é a sua "
-"especialidade. Se você pedir ajuda para a comunidade usuária de computadores "
-"para procurar por uma publicação prévia da mesma idéia, para utilizar como "
-"prova para derrubar a patente, nós todos deveriamos responder com qualquer "
-"informação útil que nós podemos ter."
+"Públicas (pubpat.org)</a> pode se interessar pelo caso; essa é a "
+"especialidade dela. Se você pedir ajuda para a comunidade usuária de "
+"computadores para procurar por uma publicação prévia da mesma ideia, para "
+"utilizar como prova para derrubar a patente, nós todos deveríamos responder "
+"com qualquer informação útil que nós podemos ter."
 
 #. type: Content of: <p>
 msgid ""
@@ -97,13 +99,13 @@ msgid ""
 "never clear these mines as fast as they plant more."
 msgstr ""
 "No entanto, combater patentes uma por uma nunca vai eliminar o perigo das "
-"patentes de software, da mesmo forma que esmagar mosquitos nunca vai "
-"eliminar a malária. Você não pode esperar que pode derrotar todas as "
+"patentes de software, da mesma forma que esmagar mosquitos nunca vai "
+"eliminar a malária. Você não pode esperar ser capaz de derrotar todas as "
 "patentes que ameaçam você, mais do que você pode esperar matar cada monstro "
 "em um jogo de video game: mais cedo ou mais tarde, alguma vai derrotar você "
 "e danificar o seu programa. O escritório de patentes dos Estados Unidos "
-"emide cerca de cem mil patentes de software por ano; nossos melhores "
-"esforços nun conseguiram eliminar essas minas tão rápido quanto eles "
+"emite cerca de cem mil patentes de software por ano; nossos melhores "
+"esforços não conseguiram eliminar essas minas tão rápido quanto eles "
 "instalam mais."
 
 #. type: Content of: <p>
@@ -154,7 +156,7 @@ msgid ""
 msgstr ""
 "Não existe conflito entre essas duas campanhas: nós podemos trabalhar na "
 "saída a curto prazo e no reparo a longo prazo de uma vez só. Se nós tomarmos "
-"cuidado, nós nós podemos fazer com que os nossos esformços para derrubar "
+"cuidado, nós nós podemos fazer com que os nossos esforços para derrubar "
 "patentes de software individuais realizar uma dupla tarefa, construindo "
 "suporte para os esforços para corrigir o problema inteiro. O ponto crucial é "
 "não igualar patentes de software “más” com patentes de software erradas ou "
@@ -176,11 +178,11 @@ msgid ""
 "vote. Please refer to <a href=\"http://www.ffii.org/\"> www.ffii.org</a> for "
 "more information on how to help, and to get in touch with other activists."
 msgstr ""
-"A batalha contra patentes de software na União Européia está chegando a um "
+"A batalha contra patentes de software na União Europeia está chegando a um "
 "estágio crucial. O Parlamento Europeu votou há um ano atrás para rejeitar "
 "patentes de software de forma conclusiva. Em maio, o Conselho de Ministros "
 "votou para desfazer as modificações do Parlamento e tornar a diretiva ainda "
-"pior doq eu quando começou. No entanto, pelo menos um país que contribuiu "
+"pior do que quando começou. No entanto, pelo menos um país que contribuiu "
 "para isso já reverteu o seu voto. Nós todos devemos fazer o máximo agora "
 "para convencer um país europeu a mais para mudar o seu voto, e para "
 "convencer os novos membros eleitos do Parlamento Europeu para manter o voto "